#include <iostream>
#include <string>
#include "image.h"

using namespace std;

typedef struct _tsRGB
{
	float r;
	float g;
	float b;
} tsRGB;

cImage * compose(cImage * fg,cImage * alpha,cImage * bg)
{
	cImage * resu;
	tsRGB f,b,r;
	float a;

	resu=new cImage(fg->getWidth(),fg->getHeight(),3);

	for(int j=0;j<fg->getHeight();j++)
	{
		for(int i=0;i<fg->getWidth();i++)
		{
			f.r=((float)(*fg)(i,j,0))/256.0f;
			f.g=((float)(*fg)(i,j,1))/256.0f;
			f.b=((float)(*fg)(i,j,2))/256.0f;

			b.r=((float)(*bg)(i,j,0))/256.0f;
			b.g=((float)(*bg)(i,j,1))/256.0f;
			b.b=((float)(*bg)(i,j,2))/256.0f;

			a=((float)(*alpha)(i,j,0))/256.0f;
			r.r=f.r+(1.0f-a)*b.r;
			r.g=f.g+(1.0f-a)*b.g;
			r.b=f.b+(1.0f-a)*b.b;
			
			(*resu)(i,j,0)=(r.r<1 ? (int)(r.r*256) : 255);
			(*resu)(i,j,1)=(r.g<1 ? (int)(r.g*256) : 255);
			(*resu)(i,j,2)=(r.b<1 ? (int)(r.b*256) : 255);
		}
	}

	return resu;
}

int main(int argc,char* argv[])
{
	cImage *fg,*bg,*alpha,*resu;
	
	if (argc!=5)
	{
		cout << "compo forground.ppm alpha.ppm background.ppm resultat.ppm" << endl;
		return 0;
	}

	fg=new cImage(string(argv[1]));
	alpha=new cImage(string(argv[2]));
	bg=new cImage(string(argv[3]));

	cout << "Compose...";
	resu=compose(fg,alpha,bg);
	cout << "Fini" << endl;

	resu->savePPM(string(argv[4]));

	return 0;
}

